diff --git a/Documentation/devicetree/bindings/power_supply/axxia-reset.txt b/Documentation/devicetree/bindings/power/reset/axxia-reset.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/axxia-reset.txt
rename to Documentation/devicetree/bindings/power/reset/axxia-reset.txt
diff --git a/Documentation/devicetree/bindings/power_supply/imx-snvs-poweroff.txt b/Documentation/devicetree/bindings/power/reset/imx-snvs-poweroff.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/imx-snvs-poweroff.txt
rename to Documentation/devicetree/bindings/power/reset/imx-snvs-poweroff.txt
diff --git a/Documentation/devicetree/bindings/power_supply/msm-poweroff.txt b/Documentation/devicetree/bindings/power/reset/msm-poweroff.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/msm-poweroff.txt
rename to Documentation/devicetree/bindings/power/reset/msm-poweroff.txt
diff --git a/Documentation/devicetree/bindings/power_supply/qnap-poweroff.txt b/Documentation/devicetree/bindings/power/reset/qnap-poweroff.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/qnap-poweroff.txt
rename to Documentation/devicetree/bindings/power/reset/qnap-poweroff.txt
diff --git a/Documentation/devicetree/bindings/power_supply/restart-poweroff.txt b/Documentation/devicetree/bindings/power/reset/restart-poweroff.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/restart-poweroff.txt
rename to Documentation/devicetree/bindings/power/reset/restart-poweroff.txt
diff --git a/Documentation/devicetree/bindings/power_supply/ab8500/btemp.txt b/Documentation/devicetree/bindings/power/supply/ab8500/btemp.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/ab8500/btemp.txt
rename to Documentation/devicetree/bindings/power/supply/ab8500/btemp.txt
diff --git a/Documentation/devicetree/bindings/power_supply/ab8500/chargalg.txt b/Documentation/devicetree/bindings/power/supply/ab8500/chargalg.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/ab8500/chargalg.txt
rename to Documentation/devicetree/bindings/power/supply/ab8500/chargalg.txt
diff --git a/Documentation/devicetree/bindings/power_supply/ab8500/charger.txt b/Documentation/devicetree/bindings/power/supply/ab8500/charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/ab8500/charger.txt
rename to Documentation/devicetree/bindings/power/supply/ab8500/charger.txt
diff --git a/Documentation/devicetree/bindings/power_supply/ab8500/fg.txt b/Documentation/devicetree/bindings/power/supply/ab8500/fg.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/ab8500/fg.txt
rename to Documentation/devicetree/bindings/power/supply/ab8500/fg.txt
diff --git a/Documentation/devicetree/bindings/power/act8945a-charger.txt b/Documentation/devicetree/bindings/power/supply/act8945a-charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/act8945a-charger.txt
rename to Documentation/devicetree/bindings/power/supply/act8945a-charger.txt
diff --git a/Documentation/devicetree/bindings/power_supply/axp20x_usb_power.txt b/Documentation/devicetree/bindings/power/supply/axp20x_usb_power.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/axp20x_usb_power.txt
rename to Documentation/devicetree/bindings/power/supply/axp20x_usb_power.txt
diff --git a/Documentation/devicetree/bindings/power/bq2415x.txt b/Documentation/devicetree/bindings/power/supply/bq2415x.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/bq2415x.txt
rename to Documentation/devicetree/bindings/power/supply/bq2415x.txt
diff --git a/Documentation/devicetree/bindings/power/bq24257.txt b/Documentation/devicetree/bindings/power/supply/bq24257.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/bq24257.txt
rename to Documentation/devicetree/bindings/power/supply/bq24257.txt
diff --git a/Documentation/devicetree/bindings/power/bq25890.txt b/Documentation/devicetree/bindings/power/supply/bq25890.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/bq25890.txt
rename to Documentation/devicetree/bindings/power/supply/bq25890.txt
diff --git a/Documentation/devicetree/bindings/power_supply/charger-manager.txt b/Documentation/devicetree/bindings/power/supply/charger-manager.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/charger-manager.txt
rename to Documentation/devicetree/bindings/power/supply/charger-manager.txt
diff --git a/Documentation/devicetree/bindings/power/da9150-charger.txt b/Documentation/devicetree/bindings/power/supply/da9150-charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/da9150-charger.txt
rename to Documentation/devicetree/bindings/power/supply/da9150-charger.txt
diff --git a/Documentation/devicetree/bindings/power/da9150-fg.txt b/Documentation/devicetree/bindings/power/supply/da9150-fg.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/da9150-fg.txt
rename to Documentation/devicetree/bindings/power/supply/da9150-fg.txt
diff --git a/Documentation/devicetree/bindings/power_supply/gpio-charger.txt b/Documentation/devicetree/bindings/power/supply/gpio-charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/gpio-charger.txt
rename to Documentation/devicetree/bindings/power/supply/gpio-charger.txt
diff --git a/Documentation/devicetree/bindings/power/isp1704.txt b/Documentation/devicetree/bindings/power/supply/isp1704.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/isp1704.txt
rename to Documentation/devicetree/bindings/power/supply/isp1704.txt
diff --git a/Documentation/devicetree/bindings/power_supply/lp8727_charger.txt b/Documentation/devicetree/bindings/power/supply/lp8727_charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/lp8727_charger.txt
rename to Documentation/devicetree/bindings/power/supply/lp8727_charger.txt
diff --git a/Documentation/devicetree/bindings/power/ltc2941.txt b/Documentation/devicetree/bindings/power/supply/ltc2941.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/ltc2941.txt
rename to Documentation/devicetree/bindings/power/supply/ltc2941.txt
diff --git a/Documentation/devicetree/bindings/power_supply/max17042_battery.txt b/Documentation/devicetree/bindings/power/supply/max17042_battery.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/max17042_battery.txt
rename to Documentation/devicetree/bindings/power/supply/max17042_battery.txt
diff --git a/Documentation/devicetree/bindings/power_supply/max8925_batter.txt b/Documentation/devicetree/bindings/power/supply/max8925_batter.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/max8925_batter.txt
rename to Documentation/devicetree/bindings/power/supply/max8925_batter.txt
diff --git a/Documentation/devicetree/bindings/power_supply/olpc_battery.txt b/Documentation/devicetree/bindings/power/supply/olpc_battery.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/olpc_battery.txt
rename to Documentation/devicetree/bindings/power/supply/olpc_battery.txt
diff --git a/Documentation/devicetree/bindings/power_supply/power_supply.txt b/Documentation/devicetree/bindings/power/supply/power_supply.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/power_supply.txt
rename to Documentation/devicetree/bindings/power/supply/power_supply.txt
diff --git a/Documentation/devicetree/bindings/power/qcom,coincell-charger.txt b/Documentation/devicetree/bindings/power/supply/qcom,coincell-charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/qcom,coincell-charger.txt
rename to Documentation/devicetree/bindings/power/supply/qcom,coincell-charger.txt
diff --git a/Documentation/devicetree/bindings/power_supply/qcom_smbb.txt b/Documentation/devicetree/bindings/power/supply/qcom_smbb.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/qcom_smbb.txt
rename to Documentation/devicetree/bindings/power/supply/qcom_smbb.txt
diff --git a/Documentation/devicetree/bindings/power/rt9455_charger.txt b/Documentation/devicetree/bindings/power/supply/rt9455_charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/rt9455_charger.txt
rename to Documentation/devicetree/bindings/power/supply/rt9455_charger.txt
diff --git a/Documentation/devicetree/bindings/power/rx51-battery.txt b/Documentation/devicetree/bindings/power/supply/rx51-battery.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/rx51-battery.txt
rename to Documentation/devicetree/bindings/power/supply/rx51-battery.txt
diff --git a/Documentation/devicetree/bindings/power_supply/sbs_sbs-battery.txt b/Documentation/devicetree/bindings/power/supply/sbs_sbs-battery.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/sbs_sbs-battery.txt
rename to Documentation/devicetree/bindings/power/supply/sbs_sbs-battery.txt
diff --git a/Documentation/devicetree/bindings/power_supply/ti,bq24735.txt b/Documentation/devicetree/bindings/power/supply/ti,bq24735.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/ti,bq24735.txt
rename to Documentation/devicetree/bindings/power/supply/ti,bq24735.txt
diff --git a/Documentation/devicetree/bindings/power_supply/tps65090.txt b/Documentation/devicetree/bindings/power/supply/tps65090.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/tps65090.txt
rename to Documentation/devicetree/bindings/power/supply/tps65090.txt
diff --git a/Documentation/devicetree/bindings/power_supply/tps65217_charger.txt b/Documentation/devicetree/bindings/power/supply/tps65217_charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power_supply/tps65217_charger.txt
rename to Documentation/devicetree/bindings/power/supply/tps65217_charger.txt
diff --git a/Documentation/devicetree/bindings/power/twl-charger.txt b/Documentation/devicetree/bindings/power/supply/twl-charger.txt
similarity index 100%
rename from Documentation/devicetree/bindings/power/twl-charger.txt
rename to Documentation/devicetree/bindings/power/supply/twl-charger.txt
diff --git a/MAINTAINERS b/MAINTAINERS
index a5a6705f34e7..5bac2dfac445 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -9066,8 +9066,7 @@ M:	David Woodhouse <dwmw2@infradead.org>
 L:	linux-pm@vger.kernel.org
 T:	git git://git.infradead.org/battery-2.6.git
 S:	Maintained
-F:	Documentation/devicetree/bindings/power/
-F:	Documentation/devicetree/bindings/power_supply/
+F:	Documentation/devicetree/bindings/power/supply/
 F:	include/linux/power_supply.h
 F:	drivers/power/supply/
 